#include  <stdio.h>
#include  <unistd.h>
#include  <libc.h>    /* atoi() */
#include  <handy.h>

#define  WIDSTEP    15.0
#define  HEIGHT     18.0
#define  MAXNUM     8

struct {
    float  xloc;
    int    num;
    int    plates[MAXNUM];
} pole[3];

static void puton(int p, int sz)
{
    float h = pole[p].num * HEIGHT;
    HgSetFillColor(HG_BLUE);
    HgBoxFill(pole[p].xloc - sz * WIDSTEP, h, sz * WIDSTEP * 2, HEIGHT, 0);
    pole[p].plates[pole[p].num++] = sz;
}

static int takefrom(int p)
{
    int sz = pole[p].plates[--pole[p].num];
    float h = pole[p].num * HEIGHT;
    HgSetFillColor(HG_WHITE);
    HgBoxFill(pole[p].xloc - sz * WIDSTEP, h, sz * WIDSTEP * 2, HEIGHT, 0);
    return sz;
}

static void hanoi_init(int num)
{
    int i;

    HgOpen(WIDSTEP * (num + 1) * 6, HEIGHT * (num + 1));
    for (i = 0; i < 3; i++) {
        pole[i].xloc = WIDSTEP * (num + 1) * (i * 2 + 1);
        pole[i].num = 0;
    }
    for (i = num; i > 0; i--)
        puton(0, i);
}

static void solve_hanoi(int num, int from, int to, int via)
{
    int sz;

    if (num == 0)
        return;
    solve_hanoi(num - 1, from, via, to);
    HgSleep(0.3);
    sz = takefrom(from);
    puton(to, sz);
    solve_hanoi(num - 1, via, to, from);
}

int main(int argc, char **argv)
{
    int num = 4;

    if (argc >= 2)
        num = atoi(argv[1]);
    if (num > MAXNUM)
        return 1;
    hanoi_init(num);
    solve_hanoi(num, 0, 1, 2);
    getchar();
    return 0;
}
