/*
 レイヤー機能を使ったアニメーションのサンプル
*/

#include <stdio.h>
#include <stdlib.h>
#include <handy.h>

const int Width = 800;
const int Height = 640;
const int R = 30.0;      /* 球の半径を決める */
const int Balls = 50;

int main() {
  int win, seed, i;
  hgcolor c[Balls];
  double x[Balls], y[Balls], dx[Balls], dy[Balls];

  printf("random seed = ");
  scanf("%d",&seed);
  srand(seed); 

  win=HgOpen(Width, Height);  /* 描画ウィンドウを開く */
  HgWSetTitle(win, "sample 1"); /* 名前をつける */
  // gsetbgcolor(win, "white"); /* 背景色を白に */

  for(i=0; i< Balls; i++) {
    x[i]=(double)(rand() % (Width/2)) + Width/4;   /* x 座標位置はランダム */
    y[i]=(double)(rand() % (Height/2)) + Height/4;   /* y 座標位置もランダム */
    dx[i]=(double)(rand() % 15 + 2) / 40.0 * R;  /* x 方向の移動速度 */
    dy[i]=(double)(rand() % 15 + 2) / 40.0 * R;  /* y 方向の移動速度 */
    int k = i % 30;
    c[i]=HgRGBA((k%4)*0.33, ((k/4)%3)*0.5, ((k/12)%3)*0.5, 0.8); /* 色を設定 */
  }

  doubleLayer lays = HgWAddDoubleLayer(win);
  while(1) {
    int lid = HgLSwitch(&lays);
    HgLClear(lid);                 /* レイヤを消去 */
    for(i=0; i< Balls; i++) {
      HgWSetFillColor(lid, c[i]);
      HgWCircleFill(lid, x[i], y[i], R, 0); // 球を描く
      y[i]+= dy[i];
      if( y[i] < R || y[i] > (Height - R) ) dy[i]*=(-1.0);
      x[i]+= dx[i];  
      if( x[i] < R || x[i] > (Width - R) ) dx[i]*=(-1.0);
    }
    // HgSleep(0.05);                /* 少し待つ */
  }

  /* このプログラムは終了しないので return 0; などは無し */

}
