#include <stdio.h>
#include <handy.h>

int main(void)
{
    HgOpen(400, 400);
    HgSetIntervalTimer(1.0);
    HgSetEventMask(HG_WINDOW_EVENT_MASK);
    do {
        char *kind = "";
        hgevent *p = HgEventNonBlocking();
        if (p == NULL) {
            HgSleep(0.1);
            continue;
        }
        switch (p->type) {
        case HG_MOUSE_DOWN: kind = "mouse DOWN"; break;
        case HG_MOUSE_UP: kind = "mouse UP"; break;
        case HG_MOUSE_MOVE: kind = "mouse MOVE"; break;
        case HG_MOUSE_DRAG: kind = "mouse DRAG"; break;
        case HG_MOUSE_ENTER: kind = "mouse ENTER"; break;
        case HG_MOUSE_EXIT: kind = "mouse EXIT"; break;
        case HG_KEY_DOWN: kind = "key DOWN"; break;
        case HG_KEY_UP: kind = "key UP"; break;
        case HG_TIMER_FIRE: kind = "TIMER"; break;
        }
        if (p->type == HG_TIMER_FIRE) {
            printf("%s", kind);
        }else if (p->type & HG_MOUSE_EVENT_MASK) {
            printf("%s (%d, %d)", kind, (int)p->x, (int)p->y);
            if (p->count >= 2)
                printf(" x%d", p->count);
        }else {
            printf("%s ", kind);
            if (p->ch >= ' ' && p->ch < 0x7f)
                printf("\"%c\"", p->ch);
            else
                printf("0x%02x", (unsigned int)p->ch);
        }
        if (p->modkey) {
            if (p->modkey & HG_SHIFT_KEY)
                printf(" + Shift");
            if (p->modkey & HG_CONTROL_KEY)
                printf(" + Cntl");
            if (p->modkey & HG_OPTION_KEY)
                printf(" + Opt");
        }
        putchar('\n');
    }while (1);
    return 0;
}
