#import <stdio.h>
#import <handy.h>
#import <math.h>

double xp[360], yp[360];

int makePolygon(double x, double y, double r, int angle)
{
    int idx = 0;
    int a = 0;
    do {
        double th = (double)a * M_PI / 180;
        xp[idx] = x + r * cos(th);
        yp[idx] = y + r * sin(th);
        a = (a + angle) % 360;
        idx++;
    }while (a != 0);
    return idx;
}

int main(int argc, char **argv)
{
    int n, i;
    double w, h, r;
    
    HgScreenSize(&w, &h);
    (void)HgOpen(800, 800);
    HgSetColor(HgRGB(1.0, 0, 0));
    HgSetFillColor(HgGray(0.2));
    n = makePolygon(650, 600, 180, 144);
    HgPolygonFill(n, xp, yp, 0);
    HgSetWidth(5.0);
    n = makePolygon(360, 320, 300, 172);
    HgPolygon(n, xp, yp);
    HgSetColor(HgRGBA(1.0, 1.0, 0.0, 0.75));
    n = makePolygon(660, 220, 150, 132);
    HgPolygon(n, xp, yp);

    HgSetColor(HgRGBA(0.2, 0.2, 0.9, 0.75));
    HgSetWidth(5.0);
    n = makePolygon(150, 600, 120, 162);
    HgMoveTo(xp[n-1], yp[n-1]);
    for (i = 0; i < n; i++)
      HgLineTo(xp[i], yp[i]);

    (void)getchar();
    (void)HgClose();

    return 0;
}
